'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = function (_ref) {
  var apolloClient = _ref.apolloClient;


  function observableQueryFields(observable) {

    var fields = {};

    ['variables', 'refetch', 'fetchMore', 'updateQuery', 'startPolling', 'stopPolling', 'subscribeToMore'].forEach(function (key) {
      if (typeof observable[key] === 'function') {
        fields[key] = observable[key].bind(observable);
      } else {
        fields[key] = observable[key];
      }
    });

    return fields;
  }

  return function (document, options) {

    var operation = (0, _parser2.default)(document);
    var rid = Math.floor(1000000000 + Math.random() * 9000000000);

    function getInstance(el) {
      return el['__kapton_instance_' + rid];
    }

    function init(el) {
      if (typeof options === "string") {
        el['__kapton_observer_' + rid] = function (change) {
          getInstance(this).optionsChanged(this, change);
        };
        el._addComplexObserverEffect('__kapton_observer_' + rid + '(' + options + '.*)');
      }
    }

    var GraphQL = function () {
      function GraphQL(_ref2) {
        var _ref2$options = _ref2.options,
            options = _ref2$options === undefined ? {} : _ref2$options;

        _classCallCheck(this, GraphQL);

        this.queryObservable = null;
        this.querySubscription = null;
        this.initialOptions = options;
        this.computedOptions = typeof options === "string";
      }

      _createClass(GraphQL, [{
        key: 'optionsChanged',
        value: function optionsChanged(el, change) {
          if (change.path === this.initialOptions) {
            //console.log("full change");
          }

          if (change.base.skip) {
            if (this.currentOptions && !this.currentOptions.skip) {
              return this.unsubscribeFromQuery();
            }
            return; // skip an already skipped
          }

          this.currentOptions = change.base;
          this.subscribeToQuery(el);
        }
      }, {
        key: 'ready',
        value: function ready(el) {
          if (operation.type === "Mutation") {
            this.currentOptions = this.initialOptions;
            this.setDataToProp(el);
          }

          if (!this.computedOptions) {
            this.currentOptions = this.initialOptions;
            this.subscribeToQuery(el);
          }
        }
      }, {
        key: 'generateQueryOptions',
        value: function generateQueryOptions() {
          return (0, _lodash2.default)(this.currentOptions, ['skip', 'name']);
        }
      }, {
        key: 'createQuery',
        value: function createQuery() {
          if (operation.type === "Query") {
            this.queryObservable = apolloClient.watchQuery(Object.assign({
              query: document
            }, this.generateQueryOptions()));
          } else if (operation.type === "Subscription") {
            this.queryObservable = apolloClient.subscribe(Object.assign({
              query: document
            }, this.generateQueryOptions()));
          }
        }
      }, {
        key: 'subscribeToQuery',
        value: function subscribeToQuery(el) {
          var _this = this;

          if (operation.type === "Mutation") {
            return;
          }

          if (this.querySubscription) {
            this.queryObservable.setOptions(this.generateQueryOptions());
            return;
          }

          if (!this.queryObservable) {
            this.createQuery();
          } else {
            // unskipped query, update options before re-subscribing
            this.queryObservable.setOptions(this.generateQueryOptions());
          }

          var next = function next(result) {
            if (operation.type === "Subscription") {
              result = { data: result };
            }
            _this.setDataToProp(el, result);
          };

          var handleError = function handleError(error) {
            console.log(error);
            //if (error instanceof ApolloError) return next({ error });
            //throw error;
          };

          this.querySubscription = this.queryObservable.subscribe({
            next: next,
            error: handleError
          });
        }
      }, {
        key: 'setDataToProp',
        value: function setDataToProp(el, result) {
          var name = operation.type === "Mutation" ? "mutate" : "data";
          if (this.currentOptions && this.currentOptions.name) {
            name = this.currentOptions.name;
          }

          if (operation.type === "Mutation") {
            return el.set(name, function (opts) {
              opts.mutation = document;
              return apolloClient.mutate(opts);
            });
          }

          var data = result.data,
              loading = result.loading,
              networkStatus = result.networkStatus;


          var elmData = Object.assign({}, data, {
            loading: loading,
            networkStatus: networkStatus
          }, observableQueryFields(this.queryObservable));

          el.set(name, elmData);
        }
      }, {
        key: 'unsubscribeFromQuery',
        value: function unsubscribeFromQuery() {
          if (this.querySubscription) {
            this.querySubscription.unsubscribe();
            delete this.querySubscription;
          }
        }
      }]);

      return GraphQL;
    }();

    return {
      beforeRegister: function beforeRegister() {
        init(this);
      },


      created: function created() {
        this['__kapton_instance_' + rid] = new GraphQL({ options: options });
      },

      ready: function ready() {},
      attached: function attached() {
        getInstance(this).ready(this);
      },
      detached: function detached() {
        //graphql.detached(this);
      }
    };
  };
};

var _lodash = require('lodash.omit');

var _lodash2 = _interopRequireDefault(_lodash);

var _parser = require('./parser');

var _parser2 = _interopRequireDefault(_parser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

;